# -*- coding: utf-8 -*-

#  PyKompasMacro https://slaviationsoft.blogspot.com
#  КОМПАС-3D (23, 0, 6, 0)
#  PyKompasMacro.exe (1.7.58.117)

import pythoncom
from win32com.client import Dispatch, gencache, VARIANT

#  Получи константы
kompas6_constants = gencache.EnsureModule("{75C9F5D0-B5B8-4526-8681-9903C567D2ED}", 0, 1, 0).constants
kompas6_constants_3d = gencache.EnsureModule("{2CAF168C-7961-4B90-9DA2-701419BEEFE3}", 0, 1, 0).constants

#  Получи API интерфейсов версии 5
kompas6_api5_module = gencache.EnsureModule("{0422828C-F174-495E-AC5D-D31014DBBE87}", 0, 1, 0)
kompas_object = kompas6_api5_module.KompasObject(Dispatch("Kompas.Application.5")._oleobj_.QueryInterface(kompas6_api5_module.KompasObject.CLSID, pythoncom.IID_IDispatch))

#  Получи API интерфейсов версии 7
kompas_api7_module = gencache.EnsureModule("{69AC2981-37C0-4379-84FD-5DD2F3C0A520}", 0, 1, 0)
kompas_api_object = kompas_api7_module.IKompasAPIObject(Dispatch("Kompas.Application.7")._oleobj_.QueryInterface(kompas_api7_module.IKompasAPIObject.CLSID, pythoncom.IID_IDispatch))
application = kompas_api_object.Application

#  Получи интерфейс активного документа
kompas_document = application.ActiveDocument

#  Создай объект модели "Сплайн"
kompas_document_3d = kompas_api7_module.IKompasDocument3D(kompas_document)
part7 = kompas_document_3d.TopPart
auxiliary_geom_container = kompas_api7_module.IAuxiliaryGeomContainer(part7)
splines_3d = auxiliary_geom_container.Splines3D
spline_3d = kompas_api7_module.ISpline3D(splines_3d.Add())
spline_3d.Name = "Сплайн:2"
spline_3d.Closed = False
spline_3d.SplineOnPoles = False
spline_3d.SplineOrder = 4
spline_3d.BuildingType = kompas6_constants_3d.ksSpline3DOnPoints
model_container = kompas_api7_module.IModelContainer(part7)

curve_vertex_param = spline_3d.AddVertex(0)
curve_vertex_param.BuildingType = kompas6_constants_3d.ksLBTByPoint
curve_vertex_param.SetParamVertex(13.0, -24.0, 50.0, 0.0)
curve_vertex_param.Update()

curve_vertex_param = spline_3d.AddVertex(1)
curve_vertex_param.BuildingType = kompas6_constants_3d.ksLBTByPoint
curve_vertex_param.SetParamVertex(-61.0, 4.0, 48.0, 0.0)
curve_vertex_param.Update()

curve_vertex_param = spline_3d.AddVertex(2)
curve_vertex_param.BuildingType = kompas6_constants_3d.ksLBTByPoint
curve_vertex_param.SetParamVertex(-122.0, 17.0, 73.0, 0.0)
curve_vertex_param.Update()

spline_3d.Update()
model_object_1 = spline_3d

#  Создай объект модели "Конструктивная 3D точка"
kompas_document_3d = kompas_api7_module.IKompasDocument3D(kompas_document)
part7 = kompas_document_3d.TopPart
points_3d = model_container.Points3D
point_3d = kompas_api7_module.IPoint3D(points_3d.Add())
point_3d.Name = "Точка:1"
point_3d.ParameterType = kompas6_constants_3d.ksPCurve
point_3d.Symbol = kompas6_constants.ksDotPoint
point_3d_param_curve = kompas_api7_module.IPoint3DParamCurve(point_3d.Parameters)
part7 = kompas_document_3d.TopPart
point_3d_param_curve.SetCurveObject(part7.SelectByPoint(model_container.Objects(kompas6_constants_3d.o3d_spline), -55.493828, 2.3648616, 46.9638232)[0])
point_3d_param_curve.OffsetType = kompas6_constants_3d.ksOffsetByU
point_3d_param_curve.Offset = 49.9694234
point_3d_param_curve.Direction = True
point_3d.Update()
model_object_2 = point_3d
